part of '../../gitea.dart';

/// Represents a set of permissions.
@JsonSerializable()
class Permission {

  /// Creates a new permission.
  Permission({this.admin = false, this.pull = false, this.push = false});

  /// Creates a new permission from the specified [map] in JSON format.
  factory Permission.fromJson(Map<String, dynamic> map) => _$PermissionFromJson(map);

  /// Value indicating whether administrator access is allowed.
  @JsonKey(defaultValue: false)
  bool admin;

  /// Value indicating whether pull is allowed.
  @JsonKey(defaultValue: false)
  bool pull;

  /// Value indicating whether push is allowed.
  @JsonKey(defaultValue: false)
  bool push;

  /// Converts this object to a [Map] in JSON format.
  Map<String, dynamic> toJson() => _$PermissionToJson(this);

  /// Returns a string representation of this object.
  @override
  String toString() => 'Permission ${json.encode(this)}';
}
