part of '../../gitea.dart';

/// Wraps the version of the Gitea server.
@JsonSerializable()
class ServerVersion {

  /// Creates a new server version.
  ServerVersion(this.version);

  /// Creates a new server version from the specified [map] in JSON format.
  factory ServerVersion.fromJson(Map<String, dynamic> map) => _$ServerVersionFromJson(map);

  /// The version number.
  @JsonKey(defaultValue: '')
  final String version;

  /// Converts this object to a [Map] in JSON format.
  Map<String, dynamic> toJson() => _$ServerVersionToJson(this);

  /// Returns a string representation of this object.
  @override
  String toString() => 'ServerVersion ${json.encode(this)}';
}
