part of '../../gitea.dart';

/// Represents a team in an organization.
@JsonSerializable()
class Team {

  /// Creates a new team.
  Team(this.id, this.name);

  /// Creates a new team from the specified [map] in JSON format.
  factory Team.fromJson(Map<String, dynamic> map) => _$TeamFromJson(map);

  /// The team description.
  @JsonKey(defaultValue: '')
  String description = '';

  /// The team identifier.
  @JsonKey(defaultValue: -1)
  final int id;

  /// The team name.
  @JsonKey(defaultValue: '')
  String name;

  /// The team permission.
  @JsonKey(defaultValue: TeamPermission.none)
  String permission = TeamPermission.none;

  /// Converts this object to a [Map] in JSON format.
  Map<String, dynamic> toJson() => _$TeamToJson(this);

  /// Returns a string representation of this object.
  @override
  String toString() => 'Team ${json.encode(this)}';
}
