part of '../../gitea.dart';

/// Represents the GPG verification of a commit.
@JsonSerializable()
class PayloadCommitVerification {

  /// Creates a new commit verification.
  PayloadCommitVerification({this.isVerified = false});

  /// Creates a new commit verification from the specified [map] in JSON format.
  factory PayloadCommitVerification.fromJson(Map<String, dynamic> map) => _$PayloadCommitVerificationFromJson(map);

  /// Value indicating whether the verification has succeeded.
  @JsonKey(defaultValue: false, name: 'verified')
  bool isVerified;

  /// A custom message sent with the verification request.
  @JsonKey(defaultValue: '')
  String payload = '';

  /// A message providing details about the verification.
  @JsonKey(defaultValue: '')
  String reason = '';

  /// The signing key used for the verification.
  @JsonKey(defaultValue: '')
  String signature = '';

  /// Converts this object to a [Map] in JSON format.
  Map<String, dynamic> toJson() => _$PayloadCommitVerificationToJson(this);

  /// Returns a string representation of this object.
  @override
  String toString() => 'PayloadCommitVerification ${json.encode(this)}';
}
