part of '../../gitea.dart';

/// Represents the author or committer of a commit.
@JsonSerializable()
class PayloadUser {

  /// Creates a new payload user.
  PayloadUser(this.username);

  /// Creates a new payload user from the specified [map] in JSON format.
  factory PayloadUser.fromJson(Map<String, dynamic> map) => _$PayloadUserFromJson(map);

  /// The mail address.
  @JsonKey(defaultValue: '')
  String email = '';

  /// The full name.
  @JsonKey(defaultValue: '')
  String name = '';

  /// The name of the Gitea account.
  @JsonKey(defaultValue: '')
  final String username;

  /// Converts this object to a [Map] in JSON format.
  Map<String, dynamic> toJson() => _$PayloadUserToJson(this);

  /// Returns a string representation of this object.
  @override
  String toString() => 'PayloadUser ${json.encode(this)}';
}
